;NSIS Modern User Interface version 1.70
;PO-Timesheet Installer Script
;Autors: Stephen Strenn and Frank Bergmann

;--------------------------------
;Include Modern UI

  !include "MUI.nsh"

;--------------------------------
;General

  ;Name and file
  Name "PO-Timesheet"
  OutFile "PO-Timesheet.exe"

  ;Default installation folder
  InstallDir "$PROGRAMFILES\Project Open\PO-Timesheet"
  
  ;Get installation folder from registry if available
  InstallDirRegKey HKCU "Software\PO-Timesheet" ""

;--------------------------------
;Interface Settings

  !define MUI_ABORTWARNING
	!define MUI_HEADERIMAGE "C:\eclipse\PO-Timesheet\images\project-open.149x49.bmp"
	!define MUI_HEADERIMAGE_BITMAP_NOSTRETCH
	!define MUI_HEADERIMAGE_BITMAP "C:\eclipse\PO-Timesheet\images\project-open.149x49.bmp"
	!define MUI_ICON "C:\eclipse\PO-Timesheet\images\setup.ico"
	!define MUI_UNICON "C:\eclipse\PO-Timesheet\images\setup.ico"

;--------------------------------
;Pages

  !insertmacro MUI_PAGE_LICENSE "C:\eclipse\PO-Timesheet\License.txt"
  !insertmacro MUI_PAGE_COMPONENTS
  !insertmacro MUI_PAGE_DIRECTORY
  !insertmacro MUI_PAGE_INSTFILES
  
  !insertmacro MUI_UNPAGE_CONFIRM
  !insertmacro MUI_UNPAGE_INSTFILES
  
;--------------------------------
;Languages
 
  !insertmacro MUI_LANGUAGE "English"

;--------------------------------
;Installer Sections

Section "PO-Timesheet (required)" SecDummy

	SectionIn RO

	SetOutPath "$INSTDIR" 
	File "C:\eclipse\PO-Timesheet.jar"
	File "C:\eclipse\PO-Timesheet\images\po-timesheet.ico"
	; File "C:\eclipse\PO-Timesheet\swt-win32-3138.dll"

	SetOutPath "$INSTDIR\lib"
	; File "C:\eclipse\PO-Timesheet\lib\org.eclipse.swt.win32.win32.x86_3.1.0.jar"

	SetOutPath "$INSTDIR"

	; Write the installation path into the registry
	WriteRegStr HKLM SOFTWARE\PO-Timesheet "Install_Dir" "$INSTDIR"
  
	; Write the uninstall keys for Windows
	WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\PO-Timesheet" "DisplayName" "PO-Timesheet"
	WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\PO-Timesheet" "UninstallString" '"$INSTDIR\uninstall.exe"'
	WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\PO-Timesheet" "NoModify" 1
	WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\PO-Timesheet" "NoRepair" 1
	WriteUninstaller "uninstall.exe"
  
SectionEnd

; Optional section (can be disabled by the user)
Section "Start Menu Shortcuts"
	CreateDirectory "$SMPROGRAMS\PO-Timesheet"
	CreateShortCut "$SMPROGRAMS\PO-Timesheet\Uninstall.lnk" "$INSTDIR\uninstall.exe" "" "$INSTDIR\uninstall.exe"
	CreateShortCut "$SMPROGRAMS\PO-Timesheet\PO-Timesheet.lnk" "$INSTDIR\PO-Timesheet.jar" "" "$INSTDIR\po-timesheet.ico"
SectionEnd

;--------------------------------
;Uninstaller Section

Section "Uninstall"

	; Remove registry keys
	DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\PO-Timesheet"
	DeleteRegKey HKLM SOFTWARE\PO-Timesheet
	DeleteRegKey /ifempty HKCU "Software\PO-Timesheet"

	; Remove shortcuts
	RMDir /r "$SMPROGRAMS\PO-Timesheet"

	; Remove directories used
	RMDir /r "$INSTDIR"

SectionEnd
