/**
 * 
 */
package org.projectopen.serverstatus;

import java.awt.*;
import java.util.*;

import javax.swing.*;

import org.projectopen.debug.*;

/**
 * @author fraber
 *
 */
public class ServicePanel extends JPanel implements Logger {

	/**
	 * 
	 */
	private static final long serialVersionUID = 6360295344991781929L;
	private static Logger logger = null;

	public ServicePanel(Map map) {
		// Setup the panel 
		super();
		this.setLayout(new FlowLayout(FlowLayout.CENTER, 7, 7)); // alignment, horizontal gap and vertical gap

		// Set transparent background
		this.setOpaque(false);
		
		// Extract the interesting values from the map
		String serviceName = map.containsKey("service_name") ? (String)map.get("service_name") : "";
		String toolTipText = map.containsKey("service_tooltip") ? (String)map.get("service_tooltip") : "";
		String installStatus = map.containsKey("installed_status") ? (String)map.get("installed_status") : "clear";
		String processStatus = map.containsKey("process_status") ? (String)map.get("process_status") : "clear";
		String portStatus = map.containsKey("port_status") ? (String)map.get("port_status") : "clear";
		String logStatus = map.containsKey("log_status") ? (String)map.get("log_status") : "clear";
		
		// calculate service status as a summary of individual states
		String serviceStatus = "green";
		if ("orange" == installStatus | "orange" == processStatus | "orange" == portStatus | "orange" == logStatus) { serviceStatus = "orange"; }
		if ("red" == installStatus | "red" == processStatus | "red" == portStatus | "red" == logStatus) { serviceStatus = "red"; }
		
		// Status + Service Description
		ImageIcon imageIcon = new ImageIcon(ServicesPanel.class.getResource("/org/projectopen/serverstatus/" + serviceStatus + ".100.gif"));
		JLabel serivceLabel = new JLabel(imageIcon);
		serivceLabel.setToolTipText(toolTipText);
		serivceLabel.setText(serviceName);
		serivceLabel.setHorizontalTextPosition(JLabel.CENTER);
		serivceLabel.setVerticalTextPosition(JLabel.CENTER);
		this.add(serivceLabel);

		// Install Status
		imageIcon = new ImageIcon(ServicesPanel.class.getResource("/org/projectopen/serverstatus/bb_" + installStatus + ".gif"));
		JLabel installLabel = new JLabel(imageIcon);
		this.add(installLabel);

		// Process Status
		imageIcon = new ImageIcon(ServicesPanel.class.getResource("/org/projectopen/serverstatus/bb_" + processStatus + ".gif"));
		JLabel processLabel = new JLabel(imageIcon);
		this.add(processLabel);

		// Port Status
		imageIcon = new ImageIcon(ServicesPanel.class.getResource("/org/projectopen/serverstatus/bb_" + portStatus + ".gif"));
		JLabel portLabel = new JLabel(imageIcon);
		this.add(portLabel);

		// log Status
		imageIcon = new ImageIcon(ServicesPanel.class.getResource("/org/projectopen/serverstatus/bb_" + logStatus + ".gif"));
		JLabel logLabel = new JLabel(imageIcon);
		this.add(logLabel);

	}
	
	/* (non-Javadoc)
	 * @see org.projectopen.debug.Logger#logMessage(int, java.lang.String, java.lang.String, java.lang.String)
	 */
	@Override
	public void logMessage(int level, String domain, String message,
			String details) {
		// TODO Auto-generated method stub

	}

	/**
	 * @param args
	 */
	@SuppressWarnings({ "rawtypes", "unchecked" })
	public static void main(String[] args) {
		
		HashMap map = new HashMap();
		map.put("service_name", "AOLserver");
		map.put("service_status", "green");
		map.put("port_status", "yellow");
		map.put("process_status", "green");
		map.put("port_status", "yellow");

		// Launch a frame with the panel
        JFrame frame = new JFrame("Single Service Panel");
        frame.setBounds(0, 0, 400, 300);

		JPanel p = new ServicePanel(map);
        frame.getContentPane().add(p);

        frame.setVisible(true);
		
	}

}
